<template>
  <div id="newsPage">
    <template v-if="content">
      <h1>{{ content.title }}</h1>
      <section>
      <div class="block" :class="{'show-result': isSearchMob}">
        <div
          class="filter-years-wrapper"
          v-if="content.filter && !isSearch && !isSearchMob"
        >
          <div
            v-for="year in content.filter.items"
            :key="year.index"
            class="filter-years-btn"
          >
            <Button
              @click="setNews(year)"
              :class="{ active: currentYear === year.value }"
              >{{ year.name }}
            </Button>
          </div>
        </div>
        <!-- search -->
        <div v-if="isSearch" class="result-search">
          <span v-html="message"></span>
          <div class="btn-clean" v-html="btnClean" @click="cleanSearch">
          </div>

        </div>
        <div
          v-if="content.search_form"
          class="search-wrapper"
          @click="searchNewsMob"
          
        >
          <div
            v-for="item in content.search_form.elements"
            :class="{
              'input-search': item.code === 'search_text_ru',
              'btn-search-wr': item.code === 'btn_search_ru',
            }"
            :key="item.code"
          >
            <template v-if="item.code === 'search_text_ru'">
              <Input
                v-model="search"
                :placeholder="item.placeholder"
                @enter="searchNews"
              />
            </template>
            <div
              v-if="item.code === 'btn_search_ru'"
              @click="searchNews"
              class="btn-search"
            >
              <img
                :src="item.image"
                alt=""
              />
            </div>
          </div>
          <!-- <div class="search-mob" @click="searchNewsMob">
            <template
            v-for="item in content.search_form.elements"
            :key="item.code"
          >
            <div
              v-if="item.code === 'btn_search_ru'"
              class="btn-search"
            >
              <img
                :src="item.image"
                alt=""
              />
            </div>
          </template>
          </div> -->
        </div>
      </div>
      <div class="news-wrapper" v-if="!loading">
        <template v-if="foundNews || isSearch">
          <div
            v-for="news in foundNews"
            :key="news.id"
            class="news-block"
          >
            <NewsItem
              :img="news.previewImage"
              :link="news.code"
              :text="news.text"
              :title="news.name"
              :date="news.publication_data"
              :btn="content.filter.link_text_detail_page"
            />
          </div>
        </template>
        <template v-else>
          <div
            v-for="news in currentNews.items"
            :key="news.id"
            class="news-block"
          >
            <NewsItem
              :img="news.previewImage"
              :link="news.code"
              :text="news.text"
              :title="news.name"
              :date="news.publication_data"
              :btn="content.filter.link_text_detail_page"
            />
          </div>
        </template>

      </div>
      <div class="news-pagination" v-if="!isSearch && !loading">
        <div v-for="page in countPage">
          <Button
            @click="setPage(page)"
            :class="{ active: currentPage === page }"
            >{{ page }}</Button
          >
        </div>
      </div>
    </section>
    <transition name="fade">
      <template v-if="loading">
        <preloader />
      </template>
    </transition>
  </template>
  </div>
</template>

<script>
import { HTTP, Routes } from '../api/API';

import Button from '../components/common/button.vue';
import Input from '../components/common/input.vue';
import Preloader from '../components/common/preloader.vue';
import NewsItem from '../components/NewsItem.vue';


export default {
  components: { Button, NewsItem, Input, Preloader },
  data() {
    return {
      currentYear: undefined,
      pageContent: [],
      content: null,
      currentNews: null,
      search: '',
      currentPage: 1,
      loading: false,
      countPage: 0,
      countNewsInPage: null,
      message: '',
      foundNews: null,
      isSearch: false,
      isSearchMob: false,
      isMob: window.innerWidth < 1023 ? true : false,
      btnClean: ''
    };
  },
  mounted() {
    this.getContent();
  },
  updated() {},
  created() {

  },
  computed: {

  },
  methods: {
    setNews(el) {
      this.currentNews = el;
      this.currentYear = el.value ? el.value : undefined;
      this.currentPage = 1;
      this.getPagination();
      this.getNews(this.currentYear, this.currentPage);
    },
    setPage(page) {
      this.currentPage = page;
      this.getNews(this.currentYear, this.currentPage);
    },
    searchNews() {
      // this.search
      // console.log(' this.search: ', this.search);
      
      
      if(this.search.trim().length >= 3){
        this.isSearch = true;
        this.loading = true;
        HTTP.post(Routes.searchNews, `text=${this.search}`)
          .then((data) => {
            // console.log('data: ', data);
            this.loading = false;
            if(data.data.data.error){
              this.message = data.data.data.error.message;
              this.btnClean = data.data.data.error.btnText;
              this.foundNews = null
            }
            else if(data.data.data.result){
              this.foundNews = data.data.data.result.items;
              this.message = data.data.data.result.message;
              this.btnClean = data.data.data.result.btnText;
            }
            else if(data.data.data.warning){
              this.message = data.data.data.warning.message;
              this.btnClean = data.data.data.warning.btnText;
              this.foundNews = null
            }

          })
          .catch(e => {
            console.error(e);
          })
      }
      if(this.search.length <= 2 && this.isMob){
        this.isSearchMob = !this.isSearchMob;
      }

    },
    searchNewsMob(){
      // this.isSearchMob = true;
    },
    cleanSearch(){
      this.search = '';
      this.foundNews = null;
      this.isSearch = false;
      this.isSearchMob = false;
      this.loading = true;
      setTimeout(() => {
        this.loading = false;
      }, 500);
    },
    getPagination() {
      const countNews = this.content.filter.items.forEach(year => {
        if (year.value === this.currentYear) {
          this.countPage = Math.ceil(year.amount / this.countNewsInPage); //кол-во новостей в выбранном году делим и округляем
        }
      });
    },
    getContent() {
      HTTP.get(Routes.news)
        .then(response => {
          // console.log('response.data.news: ', response.data.data.content);

          this.pageContent = response.data.data.content;
          this.pageContent.forEach(item => {
            switch (item.type) {
              case 'template_list_news':
                this.content = item;
                this.currentNews = item.filter.items[0];
                // console.log('this.content: ', this.content);
                // console.log('this.currentNews: ', this.currentNews);
                this.countNewsInPage = this.content.filter.cntPerPage; //кол-во выводимых на страницу новостей
                this.countPage = Math.ceil(this.currentNews.amount / this.countNewsInPage);
                break;
              default:
                break;
            }
          });
        })
        .catch(error => {
          console.log(error);
        });
    },
    getNews(year, page) {
      HTTP.get(`${Routes.newsyear}year=${year}&ipage=${page}`)
        .then(response => {
          this.currentNews = response.data.data;
          this.loading = false;
        })
        .catch(error => {
          console.log(error);
        });
    },
  },
};
</script>

<style></style>
